# ADTypes.jl: Multi-Valued Logic for Automatic Differentiation Choices

[![Docs stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://docs.sciml.ai/ADTypes/stable/)
[![Docs dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://docs.sciml.ai/ADTypes/dev/)
[![Build Status](https://github.com/SciML/ADTypes.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/SciML/ADTypes.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/SciML/ADTypes.jl/branch/main/graph/badge.svg)](https://app.codecov.io/gh/SciML/ADTypes.jl)

ADTypes.jl is a multi-valued logic system to choose an automatic differentiation (AD) package and specify its parameters.

## Which AD libraries are supported?

See the API reference in the documentation.
If a given package is missing, feel free to open an issue or pull request.

## Why should AD users adopt this standard?

A natural approach is to use a keyword argument with e.g. `Bool` or `Symbol` values.
Let's see a few examples to understand why this is not enough:

  - `autodiff = true`: ambiguous, we don't know which AD package should be used
  - `autodiff = :forward`: ambiguous, there are several AD packages implementing both forward and reverse mode (and there are other modes beyond that)
  - `autodiff = :Enzyme`: ambiguous, some AD packages can work both in forward and reverse mode
  - `autodiff = (:Enzyme, :forward)`: not too bad, but many AD packages require additional configuration (number of chunks, tape compilation, etc.)

A more involved struct is thus required, with package-specific parameters.
If every AD user develops their own version of said struct, it will ruin interoperability.
This is why ADTypes.jl provides a single set of shared types for this task, as an extremely lightweight dependency.
They are types and not enums because we need AD choice information statically to use it for dispatch.

module ADTypesEnzymeCoreExt

using ADTypes: ADTypes, AutoEnzyme
using EnzymeCore: EnzymeCore

ADTypes.mode(::AutoEnzyme{M}) where {M <: EnzymeCore.ForwardMode} = ADTypes.ForwardMode()
ADTypes.mode(::AutoEnzyme{M}) where {M <: EnzymeCore.ReverseMode} = ADTypes.ReverseMode()

end

# Backward compatibility with `public` keyword, as suggested in
# https://discourse.julialang.org/t/is-compat-jl-worth-it-for-the-public-keyword/119041/22
macro public(ex)
    return if VERSION >= v"1.11.0-DEV.469"
        args = ex isa Symbol ? (ex,) :
            Base.Meta.isexpr(ex, :tuple) ? ex.args : error("Failed to mark $ex as public")
        esc(Expr(:public, args...))
    else
        nothing
    end
end

include(joinpath(@__DIR__, "shared", "test_setup.jl"))

using SparseArrays: sparse

struct ExternalADType <: AbstractADType end
ADTypes.mode(::ExternalADType) = ForwardMode()

struct ExternalSparsityDetector <: ADTypes.AbstractSparsityDetector end
ADTypes.jacobian_sparsity(f, x, ::ExternalSparsityDetector) = trues(length(f(x)), length(x))
ADTypes.jacobian_sparsity(f!, y, x, ::ExternalSparsityDetector) = trues(length(y), length(x))
ADTypes.hessian_sparsity(f, x, ::ExternalSparsityDetector) = trues(length(x), length(x))

struct ExternalColoringAlgorithm <: ADTypes.AbstractColoringAlgorithm end
ADTypes.column_coloring(M, ::ExternalColoringAlgorithm) = 1:size(M, 2)
ADTypes.row_coloring(M, ::ExternalColoringAlgorithm) = 1:size(M, 1)
ADTypes.symmetric_coloring(M, ::ExternalColoringAlgorithm) = 1:size(M, 1)

@testset "External public interface contracts" begin
    ad = ExternalADType()
    @test mode(ad) isa ForwardMode

    x = rand(2)
    y = similar(x)
    f(x) = vcat(x, x)
    f!(y, x) = y .= x
    detector = ExternalSparsityDetector()
    @test size(jacobian_sparsity(f, x, detector)) == (4, 2)
    @test size(jacobian_sparsity(f!, y, x, detector)) == (2, 2)
    @test size(hessian_sparsity(sum, x, detector)) == (2, 2)

    colors = ExternalColoringAlgorithm()
    M = trues(2, 3)
    @test column_coloring(M, colors) == 1:3
    @test row_coloring(M, colors) == 1:2
    @test symmetric_coloring(trues(2, 2), colors) == 1:2
end

@testset "Subtyping" begin
    for ad in every_ad()
        sparse_ad = AutoSparse(ad)
        @test sparse_ad isa AbstractADType
        if mode(ad) isa ForwardMode
            @test mode(sparse_ad) isa ForwardMode
        elseif mode(ad) isa ForwardOrReverseMode
            @test mode(sparse_ad) isa ForwardOrReverseMode
        elseif mode(ad) isa ReverseMode
            @test mode(sparse_ad) isa ReverseMode
        elseif mode(ad) isa SymbolicMode
            @test mode(sparse_ad) isa SymbolicMode
        end
        @test dense_ad(ad) == ad
        @test dense_ad(sparse_ad) == ad
        @test sparsity_detector(sparse_ad) == NoSparsityDetector()
        @test coloring_algorithm(sparse_ad) == NoColoringAlgorithm()
    end
end

@testset "Sparsity detector" begin
    f_jac1(x) = vcat(x, x)
    f_jac2(x) = hcat(x, x)
    function f_jac! end
    f_hess(x) = sum(x)

    @testset "NoSparsityDetector" begin
        sd = NoSparsityDetector()

        for x in (rand(2), rand(2, 3)), f in (f_jac1, f_jac2)

            y = f(x)
            Js = jacobian_sparsity(f, x, sd)
            @test Js isa AbstractMatrix
            @test size(Js) == (length(y), length(x))
            @test all(isone, Js)
        end

        for x in (rand(2), rand(2, 3)), y in (rand(5), rand(5, 6))

            Js = jacobian_sparsity(f_jac!, y, x, sd)
            @test Js isa AbstractMatrix
            @test size(Js) == (length(y), length(x))
            @test all(isone, Js)
        end

        for x in (rand(2), rand(2, 3))
            Hs = hessian_sparsity(f_hess, x, sd)
            @test Hs isa AbstractMatrix
            @test size(Hs) == (length(x), length(x))
            @test all(isone, Hs)
        end
    end

    @testset "KnownJacobianSparsityDetector" begin
        @testset "Pattern element types" begin
            # Consumers treat any nonzero entry as a structural nonzero, so patterns
            # written as integer or float ones and zeroes are stored and returned as-is.
            Jbool = rand(Bool, 4, 2)
            x = rand(2)
            y = rand(4)
            for J in (
                    Jbool, BitMatrix(Jbool), Int.(Jbool), UInt8.(Jbool),
                    Float64.(Jbool), Float32.(Jbool), sparse(Float64.(Jbool)),
                    Any[Int(v) for v in Jbool],
                )
                sd = KnownJacobianSparsityDetector(J)
                @test sd isa KnownJacobianSparsityDetector{typeof(J)}
                @test jacobian_sparsity(f_jac1, x, sd) === J
                @test jacobian_sparsity(f_jac!, y, x, sd) === J
                @test eltype(jacobian_sparsity(f_jac1, x, sd)) === eltype(J)
            end
        end

        @testset "Jacobian sparsity detection" begin
            @testset "Out-of-place functions" begin
                for sx in ((2,), (2, 3)), f in (f_jac1, f_jac2)

                    x = rand(sx...)
                    nx = length(x)
                    Jref = rand(Bool, 2 * nx, nx)
                    sd = KnownJacobianSparsityDetector(Jref)
                    Js = jacobian_sparsity(f, x, sd)
                    @test Js isa AbstractMatrix
                    @test size(Js) == (2 * nx, nx)
                    @test Js === Jref
                end
            end
            @testset "In-place functions" begin
                for sx in ((2,), (2, 3)), sy in ((5,), (5, 6))

                    x, y = rand(sx...), rand(sy...)
                    nx, ny = length(x), length(y)
                    Jref = rand(Bool, ny, nx)
                    sd = KnownJacobianSparsityDetector(Jref)
                    Js = jacobian_sparsity(f_jac!, y, x, sd)
                    @test Js isa AbstractMatrix
                    @test size(Js) == (ny, nx)
                    @test Js === Jref
                end
            end
        end
        @testset "Exceptions: Hessian sparsity detection not supported" begin
            for sx in ((2,), (2, 3))
                x = rand(sx...)
                nx = length(x)
                Href = rand(Bool, nx, nx)
                sd = KnownJacobianSparsityDetector(Href)
                @test_throws ArgumentError hessian_sparsity(f_hess, x, sd)
            end
        end
        @testset "Exceptions: DimensionMismatch" begin
            # wrong Jacobian size
            for J in (rand(Bool, 6, 7), Int.(rand(Bool, 6, 7)), Float64.(rand(Bool, 6, 7)))
                sd = KnownJacobianSparsityDetector(J)
                for x in (rand(2), rand(2, 3)), f in (f_jac1, f_jac2)

                    @test_throws DimensionMismatch jacobian_sparsity(f, x, sd)
                end
                for x in (rand(2), rand(2, 3)), y in (rand(5), rand(5, 6))

                    @test_throws DimensionMismatch jacobian_sparsity(f_jac!, y, x, sd)
                end
            end
        end
    end

    @testset "KnownHessianSparsityDetector" begin
        @testset "Pattern element types" begin
            Hbool = rand(Bool, 2, 2)
            x = rand(2)
            for H in (
                    Hbool, BitMatrix(Hbool), Int.(Hbool), UInt8.(Hbool),
                    Float64.(Hbool), Float32.(Hbool), sparse(Float64.(Hbool)),
                    Any[Int(v) for v in Hbool],
                )
                sd = KnownHessianSparsityDetector(H)
                @test sd isa KnownHessianSparsityDetector{typeof(H)}
                @test hessian_sparsity(f_hess, x, sd) === H
                @test eltype(hessian_sparsity(f_hess, x, sd)) === eltype(H)
            end
        end

        @testset "Hessian sparsity detection" begin
            for sx in ((2,), (2, 3))
                x = rand(sx...)
                nx = length(x)
                Href = rand(Bool, nx, nx)
                sd = KnownHessianSparsityDetector(Href)

                Hs = hessian_sparsity(f_hess, x, sd)
                @test Hs isa AbstractMatrix
                @test size(Hs) == (nx, nx)
                @test Hs === Href
            end
        end
        @testset "Exceptions: Jacobian sparsity detection not supported" begin
            @testset "Out-of-place functions" begin
                for sx in ((2,), (2, 3)), f in (f_jac1, f_jac2)

                    x = rand(sx...)
                    nx = length(x)
                    Jref = rand(Bool, 2 * nx, nx)
                    sd = KnownHessianSparsityDetector(Jref)
                    @test_throws ArgumentError jacobian_sparsity(f, x, sd)
                end
            end
            @testset "In-place functions" begin
                for sx in ((2,), (2, 3)), sy in ((5,), (5, 6))

                    x, y = rand(sx...), rand(sy...)
                    nx, ny = length(x), length(y)
                    Jref = rand(Bool, ny, nx)
                    sd = KnownHessianSparsityDetector(Jref)
                    @test_throws ArgumentError jacobian_sparsity(f_jac!, y, x, sd)
                end
            end
        end
        @testset "Exceptions: DimensionMismatch" begin
            # wrong Hessian size
            for H in (rand(Bool, 2, 3), Int.(rand(Bool, 2, 3)), Float64.(rand(Bool, 2, 3)))
                sd = KnownHessianSparsityDetector(H)
                for x in (rand(2), rand(2, 3))
                    @test_throws DimensionMismatch hessian_sparsity(f_hess, x, sd)
                end
            end
        end
    end
end

@testset "Coloring algorithm" begin
    ca = NoColoringAlgorithm()

    for M in (rand(2, 3), rand(3, 2))
        cv = column_coloring(M, ca)
        @test cv isa AbstractVector{<:Integer}
        @test length(cv) == size(M, 2)
        @test allunique(cv)

        rv = row_coloring(M, ca)
        @test rv isa AbstractVector{<:Integer}
        @test length(rv) == size(M, 1)
        @test allunique(rv)
    end

    M = rand(3, 3)
    sv = symmetric_coloring(M, ca)
    @test sv isa AbstractVector{<:Integer}
    @test length(sv) == size(M, 1) == size(M, 2)
    @test allunique(sv)
end

"""
    AutoChainRules{RC}

Struct used to select an automatic differentiation backend based on [ChainRulesCore.jl](https://github.com/JuliaDiff/ChainRulesCore.jl) (see the list [here](https://juliadiff.org/ChainRulesCore.jl/stable/index.html#ChainRules-roll-out-status)).

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoChainRules(; ruleconfig)

# Fields

  - `ruleconfig::RC`: a [`ChainRulesCore.RuleConfig`](https://juliadiff.org/ChainRulesCore.jl/stable/rule_author/superpowers/ruleconfig.html) object.
"""
Base.@kwdef struct AutoChainRules{RC} <: AbstractADType
    ruleconfig::RC
end

mode(::AutoChainRules) = ForwardOrReverseMode()  # specialized in the extension

function Base.show(io::IO, backend::AutoChainRules)
    return print(io, AutoChainRules, "(ruleconfig=", repr(backend.ruleconfig; context = io), ")")
end

"""
    AutoDiffractor

Struct used to select the [Diffractor.jl](https://github.com/JuliaDiff/Diffractor.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoDiffractor()
"""
struct AutoDiffractor <: AbstractADType end

mode(::AutoDiffractor) = ForwardOrReverseMode()

"""
    AutoEnzyme{M,A}

Struct used to select the [Enzyme.jl](https://github.com/EnzymeAD/Enzyme.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoEnzyme(; mode::M=nothing, function_annotation::Type{A}=Nothing)

# Type parameters

  - `A` determines how the function `f` to differentiate is passed to Enzyme. It can be:

      + a subtype of `EnzymeCore.Annotation` (like `EnzymeCore.Const` or `EnzymeCore.Duplicated`) to enforce a given annotation
      + `Nothing` to simply pass `f` and let Enzyme choose the most appropriate annotation

# Fields

  - `mode::M` determines the autodiff mode (forward or reverse). It can be:

      + an object subtyping `EnzymeCore.Mode` (like `EnzymeCore.Forward` or `EnzymeCore.Reverse`) if a specific mode is required
      + `nothing` to choose the best mode automatically
"""
struct AutoEnzyme{M, A} <: AbstractADType
    mode::M
end

function AutoEnzyme(;
        mode::M = nothing, function_annotation::Type{A} = Nothing
    ) where {M, A}
    return AutoEnzyme{M, A}(mode)
end

mode(::AutoEnzyme) = ForwardOrReverseMode()  # specialized in the extension

function Base.show(io::IO, backend::AutoEnzyme{M, A}) where {M, A}
    print(io, AutoEnzyme, "(")
    !isnothing(backend.mode) && print(io, "mode=", repr(backend.mode; context = io))
    !isnothing(backend.mode) && !(A <: Nothing) && print(io, ", ")
    !(A <: Nothing) && print(io, "function_annotation=", repr(A; context = io))
    return print(io, ")")
end


"""
    AutoReactant{M<:AutoEnzyme}

Struct used to select the [Reactant.jl](https://github.com/EnzymeAD/Reactant.jl) compilation atop Enzyme for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoReactant(; mode::Union{AutoEnzyme,Nothing}=nothing)

# Fields

  - `mode::M` specifies the parameterization of differentiation.  It can be:

      + an [`AutoEnzyme`](@ref) object if a specific mode is required
      + `nothing` to choose the best mode automatically
"""
struct AutoReactant{M <: AutoEnzyme} <: AbstractADType
    mode::M
end

function AutoReactant(;
        mode::Union{AutoEnzyme, Nothing} = nothing
    )
    if mode === nothing
        mode = AutoEnzyme()
    end
    return AutoReactant(mode)
end

mode(r::AutoReactant) = mode(r.mode)

function Base.show(io::IO, backend::AutoReactant)
    print(io, AutoReactant, "(")
    print(io, "mode=", repr(backend.mode; context = io))
    return print(io, ")")
end

"""
    AutoFastDifferentiation

Struct used to select the [FastDifferentiation.jl](https://github.com/brianguenter/FastDifferentiation.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoFastDifferentiation()
"""
struct AutoFastDifferentiation <: AbstractADType end

mode(::AutoFastDifferentiation) = SymbolicMode()

"""
    AutoFiniteDiff{T1,T2,T3}

Struct used to select the [FiniteDiff.jl](https://github.com/JuliaDiff/FiniteDiff.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoFiniteDiff(;
        fdtype=Val(:forward), fdjtype=fdtype, fdhtype=Val(:hcentral),
        relstep=nothing, absstep=nothing, dir=true
    )

# Fields

  - `fdtype::T1`: finite difference type
  - `fdjtype::T2`: finite difference type for the Jacobian
  - `fdhtype::T3`: finite difference type for the Hessian
  - `relstep`: relative finite difference step size
  - `absstep`: absolute finite difference step size
  - `dir`: direction of the finite difference step
"""
Base.@kwdef struct AutoFiniteDiff{T1, T2, T3, S1, S2, S3} <: AbstractADType
    fdtype::T1 = Val(:forward)
    fdjtype::T2 = fdtype
    fdhtype::T3 = Val(:hcentral)
    relstep::S1 = nothing
    absstep::S2 = nothing
    dir::S3 = true
end

mode(::AutoFiniteDiff) = ForwardMode()

function Base.show(io::IO, backend::AutoFiniteDiff)
    print(io, AutoFiniteDiff, "(")
    backend.fdtype != Val(:forward) &&
        print(io, "fdtype=", repr(backend.fdtype; context = io), ", ")
    backend.fdjtype != backend.fdtype &&
        print(io, "fdjtype=", repr(backend.fdjtype; context = io), ", ")
    backend.fdhtype != Val(:hcentral) &&
        print(io, "fdhtype=", repr(backend.fdhtype; context = io), ", ")
    !isnothing(backend.relstep) &&
        print(io, "relstep=", repr(backend.relstep; context = io), ", ")
    !isnothing(backend.absstep) &&
        print(io, "absstep=", repr(backend.absstep; context = io), ", ")
    backend.dir != true &&
        print(io, "dir=", repr(backend.dir; context = io))
    return print(io, ")")
end

"""
    AutoFiniteDifferences{T}

Struct used to select the [FiniteDifferences.jl](https://github.com/JuliaDiff/FiniteDifferences.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoFiniteDifferences(; fdm)

# Fields

  - `fdm::T`: a [`FiniteDifferenceMethod`](https://juliadiff.org/FiniteDifferences.jl/stable/pages/api/#FiniteDifferences.FiniteDifferenceMethod)
"""
Base.@kwdef struct AutoFiniteDifferences{T} <: AbstractADType
    fdm::T
end

mode(::AutoFiniteDifferences) = ForwardMode()

function Base.show(io::IO, backend::AutoFiniteDifferences)
    return print(io, AutoFiniteDifferences, "(fdm=", repr(backend.fdm; context = io), ")")
end

"""
    AutoForwardDiff{chunksize,T}

Struct used to select the [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoForwardDiff(; chunksize=nothing, tag=nothing)

# Type parameters

  - `chunksize`: the preferred [chunk size](https://juliadiff.org/ForwardDiff.jl/stable/user/advanced/#Configuring-Chunk-Size) to evaluate several derivatives at once

# Fields

  - `tag::T`: a [custom tag](https://juliadiff.org/ForwardDiff.jl/release-0.10/user/advanced.html#Custom-tags-and-tag-checking-1) to handle nested differentiation calls (usually not necessary)
"""
struct AutoForwardDiff{chunksize, T} <: AbstractADType
    tag::T
end

AutoForwardDiff{chunksize}(tag::T) where {chunksize, T} = AutoForwardDiff{chunksize, T}(tag)

function AutoForwardDiff(; chunksize = nothing, tag = nothing)
    return AutoForwardDiff{chunksize}(tag)
end

mode(::AutoForwardDiff) = ForwardMode()

function Base.show(io::IO, backend::AutoForwardDiff{chunksize}) where {chunksize}
    print(io, AutoForwardDiff, "(")
    chunksize !== nothing && print(
        io, "chunksize=", repr(chunksize; context = io),
        (backend.tag !== nothing ? ", " : "")
    )
    backend.tag !== nothing && print(io, "tag=", repr(backend.tag; context = io))
    return print(io, ")")
end

"""
    AutoTaylorDiff{order}

Struct used to select the [TaylorDiff.jl](https://github.com/JuliaDiff/TaylorDiff.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoTaylorDiff(; order = 1)

# Type parameters

  - `order`: the order of the Taylor-mode automatic differentiation
"""
struct AutoTaylorDiff{order} <: AbstractADType end

function AutoTaylorDiff(; order = 1)
    return AutoTaylorDiff{order}()
end

mode(::AutoTaylorDiff) = ForwardMode()

function Base.show(io::IO, ::AutoTaylorDiff{order}) where {order}
    print(io, AutoTaylorDiff, "(")
    print(io, "order=", repr(order; context = io))
    return print(io, ")")
end

"""
    AutoGTPSA{D}

Struct used to select the [GTPSA.jl](https://github.com/bmad-sim/GTPSA.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoGTPSA(; descriptor=nothing)

# Fields

  - `descriptor::D`: can be either

      + a GTPSA `Descriptor` specifying the number of variables/parameters, parameter
        order, individual variable/parameter truncation orders, and maximum order. See
        the [GTPSA.jl documentation](https://bmad-sim.github.io/GTPSA.jl/stable/man/b_descriptor/) for more details.
      + `nothing` to automatically use a `Descriptor` given the context.
"""
Base.@kwdef struct AutoGTPSA{D} <: AbstractADType
    descriptor::D = nothing
end

mode(::AutoGTPSA) = ForwardMode()

function Base.show(io::IO, backend::AutoGTPSA{D}) where {D}
    print(io, AutoGTPSA, "(")
    D != Nothing && print(io, "descriptor=", repr(backend.descriptor; context = io))
    return print(io, ")")
end

"""
    AutoMooncake

Struct used to select the [Mooncake.jl](https://github.com/compintell/Mooncake.jl) backend for automatic differentiation in reverse mode.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

!!! info

    When forward mode became available in Mooncake.jl v0.4.147, another struct called [`AutoMooncakeForward`](@ref) was introduced.
    It was kept separate to avoid a breaking release of ADTypes.jl.
    [`AutoMooncake`](@ref) remains for reverse mode only.

# Constructors

    AutoMooncake(; config=nothing)

# Fields

  - `config`: either `nothing` or an instance of `Mooncake.Config` -- see the docstring of `Mooncake.Config` for more information. `AutoMooncake(; config=nothing)` is equivalent to `AutoMooncake(; config=Mooncake.Config())`, i.e. the default configuration.
"""
Base.@kwdef struct AutoMooncake{Tconfig} <: AbstractADType
    config::Tconfig = nothing
end

mode(::AutoMooncake) = ReverseMode()

function Base.show(io::IO, backend::AutoMooncake)
    print(io, AutoMooncake, "(")
    backend.config !== nothing &&
        print(io, "config=", repr(backend.config; context = io))
    return print(io, ")")
end

"""
    AutoMooncakeForward

Struct used to select the [Mooncake.jl](https://github.com/compintell/Mooncake.jl) backend for automatic differentiation in forward mode.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

!!! info

    This struct was introduced when forward mode became available in Mooncake.jl v0.4.147.
    It was kept separate from [`AutoMooncake`](@ref) to avoid a breaking release of ADTypes.jl.
    [`AutoMooncake`](@ref) remains for reverse mode only.

# Constructors

    AutoMooncakeForward(; config=nothing)

# Fields

  - `config`: either `nothing` or an instance of `Mooncake.Config` -- see the docstring of `Mooncake.Config` for more information. `AutoMooncakeForward(; config=nothing)` is equivalent to `AutoMooncakeForward(; config=Mooncake.Config())`, i.e. the default configuration.
"""
Base.@kwdef struct AutoMooncakeForward{Tconfig} <: AbstractADType
    config::Tconfig = nothing
end

mode(::AutoMooncakeForward) = ForwardMode()

function Base.show(io::IO, backend::AutoMooncakeForward)
    print(io, AutoMooncakeForward, "(")
    backend.config !== nothing &&
        print(io, "config=", repr(backend.config; context = io))
    return print(io, ")")
end

"""
    AutoPolyesterForwardDiff{chunksize,T}

Struct used to select the [PolyesterForwardDiff.jl](https://github.com/JuliaDiff/PolyesterForwardDiff.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoPolyesterForwardDiff(; chunksize=nothing, tag=nothing)

# Type parameters

  - `chunksize`: the preferred [chunk size](https://juliadiff.org/ForwardDiff.jl/stable/user/advanced/#Configuring-Chunk-Size) to evaluate several derivatives at once

# Fields

  - `tag::T`: a [custom tag](https://juliadiff.org/ForwardDiff.jl/release-0.10/user/advanced.html#Custom-tags-and-tag-checking-1) to handle nested differentiation calls (usually not necessary)
"""
struct AutoPolyesterForwardDiff{chunksize, T} <: AbstractADType
    tag::T
end

function AutoPolyesterForwardDiff{chunksize}(tag::T) where {chunksize, T}
    return AutoPolyesterForwardDiff{chunksize, T}(tag)
end

function AutoPolyesterForwardDiff(; chunksize = nothing, tag = nothing)
    return AutoPolyesterForwardDiff{chunksize}(tag)
end

mode(::AutoPolyesterForwardDiff) = ForwardMode()

function Base.show(io::IO, backend::AutoPolyesterForwardDiff{chunksize}) where {chunksize}
    print(io, AutoPolyesterForwardDiff, "(")
    chunksize !== nothing && print(
        io, "chunksize=", repr(chunksize; context = io),
        (backend.tag !== nothing ? ", " : "")
    )
    backend.tag !== nothing && print(io, "tag=", repr(backend.tag; context = io))
    return print(io, ")")
end

"""
    AutoReverseDiff{compile}

Struct used to select the [ReverseDiff.jl](https://github.com/JuliaDiff/ReverseDiff.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoReverseDiff(; compile::Union{Val, Bool} = Val(false))

# Fields

  - `compile::Union{Val, Bool}`: whether to allow pre-recording and reusing a tape (which speeds up the differentiation process).

      + If `compile=false` or `compile=Val(false)`, a new tape must be recorded at every call to the differentiation operator.
      + If `compile=true` or `compile=Val(true)`, a tape can be pre-recorded on an example input and then reused at every differentiation call.

    The boolean version of this keyword argument is taken as the type parameter.

!!! warning

    Pre-recording a tape only captures the path taken by the differentiated function _when executed on the example input_.
    If said function has value-dependent branching behavior, reusing pre-recorded tapes can lead to incorrect results.
    In such situations, you should keep the default setting `compile=Val(false)`.
    For more details, please refer to ReverseDiff's [`AbstractTape` API documentation](https://juliadiff.org/ReverseDiff.jl/dev/api/#The-AbstractTape-API).

!!! info

    Despite what its name may suggest, the `compile` setting does not prescribe whether or not the tape is compiled with [`ReverseDiff.compile`](https://juliadiff.org/ReverseDiff.jl/dev/api/#ReverseDiff.compile) after being recorded.
    This is left as a private implementation detail.
"""
struct AutoReverseDiff{C} <: AbstractADType
    compile::Bool  # this field is left for legacy reasons

    function AutoReverseDiff(; compile::Union{Val, Bool} = Val(false))
        _compile = _unwrap_val(compile)
        return new{_compile}(_compile)
    end
end

function Base.getproperty(ad::AutoReverseDiff, s::Symbol)
    if s === :compile
        Base.depwarn(
            "`ad.compile` where `ad` is `AutoReverseDiff` has been deprecated and will be removed in v2. Instead it is available as a compile-time constant as `AutoReverseDiff{true}` or `AutoReverseDiff{false}`.",
            :getproperty
        )
    end
    return getfield(ad, s)
end

mode(::AutoReverseDiff) = ReverseMode()

function Base.show(io::IO, ::AutoReverseDiff{compile}) where {compile}
    print(io, AutoReverseDiff, "(")
    compile && print(io, "compile=true")
    return print(io, ")")
end

"""
    AutoSymbolics

Struct used to select the [Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoSymbolics()
"""
struct AutoSymbolics <: AbstractADType end

mode(::AutoSymbolics) = SymbolicMode()

"""
    AutoTapir

!!! danger

    `AutoTapir` is deprecated following a package renaming, please use [`AutoMooncake`](@ref) instead.

Struct used to select the [Tapir.jl](https://github.com/compintell/Tapir.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoTapir(; safe_mode=true)

# Fields

  - `safe_mode::Bool`: whether to run additional checks to catch errors early.
"""
struct AutoTapir <: AbstractADType
    safe_mode::Bool
end

mode(::AutoTapir) = ReverseMode()

function Base.show(io::IO, backend::AutoTapir)
    print(io, AutoTapir, "(")
    !(backend.safe_mode) && print(io, "safe_mode=false")
    return print(io, ")")
end

"""
    AutoTracker

Struct used to select the [Tracker.jl](https://github.com/FluxML/Tracker.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoTracker()
"""
struct AutoTracker <: AbstractADType end

mode(::AutoTracker) = ReverseMode()

"""
    AutoZygote

Struct used to select the [Zygote.jl](https://github.com/FluxML/Zygote.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoZygote()
"""
struct AutoZygote <: AbstractADType end

mode(::AutoZygote) = ReverseMode()

"""
    AutoHyperHessians{chunksize}

Struct used to select the [HyperHessians.jl](https://github.com/KristofferC/HyperHessians.jl) backend for automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    AutoHyperHessians(; chunksize=nothing)

# Type parameters

  - `chunksize`: the preferred chunk size to evaluate several derivatives at once. If `nothing`, HyperHessians chooses automatically.
"""
struct AutoHyperHessians{chunksize} <: AbstractADType end

function AutoHyperHessians(; chunksize::Union{Nothing, Int} = nothing)
    if chunksize isa Int
        chunksize > 0 || throw(ArgumentError("chunksize must be positive, got $chunksize"))
    end
    return AutoHyperHessians{chunksize}()
end

mode(::AutoHyperHessians) = ForwardMode()

function Base.show(io::IO, ::AutoHyperHessians{chunksize}) where {chunksize}
    print(io, AutoHyperHessians, "(")
    chunksize !== nothing && print(io, "chunksize=", repr(chunksize; context = io))
    return print(io, ")")
end

"""
    NoAutoDiff

Struct used to select no automatic differentiation.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

# Constructors

    NoAutoDiff()
"""
struct NoAutoDiff <: AbstractADType end

"""
    NoAutoDiffSelectedError <: Exception

Signifies that code tried to use automatic differentiation, but [`NoAutoDiff`](@ref) was specified.

# Constructors

    NoAutoDiffSelectedError(msg::String)
"""
struct NoAutoDiffSelectedError <: Exception
    msg::String
end

NoAutoDiffSelectedError() = NoAutoDiffSelectedError("Automatic differentiation can not be used with NoAutoDiff()")

function mode(::NoAutoDiff)
    throw(NoAutoDiffSelectedError())
end

using PrecompileTools: @compile_workload

@compile_workload begin
    forward_ad = AutoForwardDiff(; chunksize = 4)
    mode(forward_ad)
    mode(AutoReverseDiff(; compile = true))
    Auto(:ForwardDiff)
    Auto(nothing)

    sparse_ad = AutoSparse(forward_ad)
    dense_ad(sparse_ad)
    sparsity_detector(sparse_ad)
    coloring_algorithm(sparse_ad)

    x = [1.0, 2.0]
    f = x -> [x[1]^2, x[2]^2]
    jacobian_sparsity(f, x, NoSparsityDetector())
    hessian_sparsity(sum, x, NoSparsityDetector())

    pattern = trues(2, 2)
    jacobian_sparsity(f, x, KnownJacobianSparsityDetector(pattern))
    hessian_sparsity(sum, x, KnownHessianSparsityDetector(pattern))

    matrix = trues(2, 3)
    coloring = NoColoringAlgorithm()
    column_coloring(matrix, coloring)
    row_coloring(matrix, coloring)
    symmetric_coloring(pattern, coloring)
end

"""
    AbstractMode

Abstract supertype for the traits identifying differentiation modes.

# Subtypes

  - [`ForwardMode`](@ref)
  - [`ReverseMode`](@ref)
  - [`ForwardOrReverseMode`](@ref)
  - [`SymbolicMode`](@ref)
"""
abstract type AbstractMode end

"""
    mode(ad::AbstractADType)

Return the differentiation mode of `ad`, as a subtype of [`AbstractMode`](@ref).

# Extension contract

Every external concrete subtype of [`AbstractADType`](@ref) must provide this
method. Return an instance of the most specific applicable mode trait; callers may
use that trait for dispatch but must not require a particular backend implementation.
"""
function mode end

"""
    ForwardMode

Trait for AD choices that rely on [forward mode](https://en.wikipedia.org/wiki/Automatic_differentiation#Forward_accumulation) algorithmic differentiation or [finite differences](https://en.wikipedia.org/wiki/Finite_difference).

These two paradigms are classified together because they can both efficiently compute Jacobian-vector products.
"""
struct ForwardMode <: AbstractMode end

"""
    ReverseMode

Trait for AD choices that rely on [reverse mode](https://en.wikipedia.org/wiki/Automatic_differentiation#Reverse_accumulation) algorithmic differentiation.
"""
struct ReverseMode <: AbstractMode end

"""
    ForwardOrReverseMode

Trait for AD choices that can work either in [`ForwardMode`](@ref) or [`ReverseMode`](@ref), depending on their configuration.

!!! warning

    This trait should rarely be used, because more precise dispatches to [`ForwardMode`](@ref) or [`ReverseMode`](@ref) should be defined.
"""
struct ForwardOrReverseMode <: AbstractMode end

"""
    SymbolicMode

Trait for AD choices that rely on [symbolic differentiation](https://en.wikipedia.org/wiki/Computer_algebra).
"""
struct SymbolicMode <: AbstractMode end

module ADTypesChainRulesCoreExt

using ADTypes: ADTypes, AutoChainRules
using ChainRulesCore: HasForwardsMode, HasReverseMode,
    RuleConfig

# see https://juliadiff.org/ChainRulesCore.jl/stable/rule_author/superpowers/ruleconfig.html

function ADTypes.mode(::AutoChainRules{RC}) where {
        RC <: RuleConfig{>:HasForwardsMode},
    }
    return ADTypes.ForwardMode()
end

function ADTypes.mode(::AutoChainRules{RC}) where {
        RC <: RuleConfig{>:HasReverseMode},
    }
    return ADTypes.ReverseMode()
end

function ADTypes.mode(::AutoChainRules{RC}) where {
        RC <: RuleConfig{>:Union{HasForwardsMode, HasReverseMode}},
    }
    # more specific than the previous two
    return ADTypes.ForwardOrReverseMode()
end

end

using SciMLTesting, ADTypes, Test
using JET

# ExplicitImports only checks an extension module when it actually exists, and an
# extension only comes into existence once its trigger package is loaded. Loading all
# three weakdeps here is what puts ADTypes' extensions under QA at all; without them
# `Base.get_extension` returns `nothing` and every extension is silently skipped.
using ChainRulesCore, ConstructionBase, EnzymeCore

# ExplicitImports silently skips an extension that fails to load, so assert the
# extension modules actually exist rather than trusting a green run_qa.
@testset "Extensions loaded" begin
    for ext in (:ADTypesChainRulesCoreExt, :ADTypesConstructionBaseExt, :ADTypesEnzymeCoreExt)
        @test Base.get_extension(ADTypes, ext) !== nothing
    end
end

# Aqua and ExplicitImports are SciMLTesting deps, so they are not imported here.
# Aqua is still listed in this env's `[deps]` (not ExplicitImports): Aqua's ambiguity
# check spawns a worker subprocess that runs a bare `using Aqua` against the active
# project, which only resolves if Aqua is a *direct* dep — a transitive (manifest-only)
# Aqua makes that worker error with "Package Aqua not found in current path".
run_qa(
    ADTypes;
    aqua_kwargs = (; deps_compat = (; check_extras = false)),
    # Four unavoidable non-public names, ignored only in the public-API access check
    # (every other ExplicitImports check passes unignored):
    #   * `broadcastable` — the documented broadcasting customization hook;
    #     `Base.broadcastable(ad::AbstractADType) = Ref(ad)` makes AD choices broadcast
    #     as scalars. `Base` marks it non-public on every Julia version.
    #   * `depwarn` — `Base.depwarn` is the only way to emit a deprecation warning, and
    #     it is non-public on the LTS (1.10). It became public in Base on 1.11+, where
    #     ignoring it is a harmless no-op.
    #   * `ForwardMode`, `ReverseMode` — EnzymeCore's mode *types*, used by
    #     ADTypesEnzymeCoreExt to dispatch `ADTypes.mode(::AutoEnzyme{M})`. EnzymeCore
    #     exports only the mode *instances* (`Forward`, `Reverse`, ...), each of which is
    #     one specific parameterization, so there is no public spelling of "any forward
    #     mode" to constrain `M` with.
    # (`Base.Meta.isexpr` in src/compat.jl was switched off `Base.isexpr` so its access
    # resolves to the public `Base.Meta` owner and needs no ignore on any version.)
    ei_kwargs = (;
        all_qualified_accesses_are_public = (;
            ignore = (:broadcastable, :depwarn, :ForwardMode, :ReverseMode),
        ),
    ),
)

include(joinpath(@__DIR__, "shared", "test_setup.jl"))

@testset "AutoChainRules" begin
    ad = AutoChainRules(; ruleconfig = ForwardOrReverseRuleConfig())
    @test ad isa AbstractADType
    @test ad isa AutoChainRules{ForwardOrReverseRuleConfig}
    @test mode(ad) isa ForwardOrReverseMode
    @test ad.ruleconfig == ForwardOrReverseRuleConfig()

    ad = AutoChainRules(; ruleconfig = ForwardRuleConfig())
    @test ad isa AbstractADType
    @test ad isa AutoChainRules{ForwardRuleConfig}
    @test mode(ad) isa ForwardMode
    @test ad.ruleconfig == ForwardRuleConfig()

    ad = AutoChainRules(; ruleconfig = ReverseRuleConfig())
    @test ad isa AbstractADType
    @test ad isa AutoChainRules{ReverseRuleConfig}
    @test mode(ad) isa ReverseMode
    @test ad.ruleconfig == ReverseRuleConfig()
end

@testset "AutoDiffractor" begin
    ad = AutoDiffractor()
    @test ad isa AbstractADType
    @test ad isa AutoDiffractor
    @test mode(ad) isa ForwardOrReverseMode
end

@testset "AutoEnzyme" begin
    ad = AutoEnzyme()
    @test ad isa AbstractADType
    @test ad isa AutoEnzyme{Nothing, Nothing}
    @test mode(ad) isa ForwardOrReverseMode
    @test ad.mode === nothing

    ad = AutoEnzyme(; mode = EnzymeCore.Forward)
    @test ad isa AbstractADType
    @test ad isa AutoEnzyme{typeof(EnzymeCore.Forward), Nothing}
    @test mode(ad) isa ForwardMode
    @test ad.mode == EnzymeCore.Forward

    ad = AutoEnzyme(; function_annotation = EnzymeCore.Const)
    @test ad isa AbstractADType
    @test ad isa AutoEnzyme{Nothing, EnzymeCore.Const}
    @test mode(ad) isa ForwardOrReverseMode
    @test ad.mode === nothing

    ad = AutoEnzyme(;
        mode = EnzymeCore.Reverse, function_annotation = EnzymeCore.Duplicated
    )
    @test ad isa AbstractADType
    @test ad isa AutoEnzyme{typeof(EnzymeCore.Reverse), EnzymeCore.Duplicated}
    @test mode(ad) isa ReverseMode
    @test ad.mode == EnzymeCore.Reverse
end

@testset "AutoReactant" begin
    ad = AutoReactant()
    @test ad isa AbstractADType
    @test ad isa AutoReactant{<:AutoEnzyme}
    @test ad.mode isa AutoEnzyme
    @test ad.mode.mode === nothing
    @test mode(ad) isa ForwardOrReverseMode

    ad = AutoReactant(; mode = AutoEnzyme(; mode = EnzymeCore.Forward))
    @test ad isa AbstractADType
    @test ad isa AutoReactant{<:AutoEnzyme{typeof(EnzymeCore.Forward), Nothing}}
    @test mode(ad) isa ForwardMode
    @test ad.mode.mode == EnzymeCore.Forward

    ad = AutoReactant(; mode = AutoEnzyme(; function_annotation = EnzymeCore.Const))
    @test ad isa AbstractADType
    @test ad isa AutoReactant{<:AutoEnzyme{Nothing, EnzymeCore.Const}}
    @test mode(ad) isa ForwardOrReverseMode
    @test ad.mode.mode === nothing

    ad = AutoReactant(;
        mode = AutoEnzyme(;
            mode = EnzymeCore.Reverse, function_annotation = EnzymeCore.Duplicated
        )
    )
    @test ad isa AbstractADType
    @test ad isa AutoReactant{<:AutoEnzyme{typeof(EnzymeCore.Reverse), EnzymeCore.Duplicated}}
    @test mode(ad) isa ReverseMode
    @test ad.mode.mode == EnzymeCore.Reverse
end

@testset "AutoFastDifferentiation" begin
    ad = AutoFastDifferentiation()
    @test ad isa AbstractADType
    @test ad isa AutoFastDifferentiation
    @test mode(ad) isa SymbolicMode
end

@testset "AutoFiniteDiff" begin
    ad = AutoFiniteDiff()
    @test ad isa AbstractADType
    @test ad isa AutoFiniteDiff
    @test mode(ad) isa ForwardMode
    @test ad.fdtype === Val(:forward)
    @test ad.fdjtype === Val(:forward)
    @test ad.fdhtype === Val(:hcentral)
    @test ad.relstep === nothing
    @test ad.absstep === nothing
    @test ad.dir

    ad = AutoFiniteDiff(;
        fdtype = Val(:central), fdjtype = Val(:forward),
        relstep = 1.0e-3, absstep = 1.0e-4, dir = false
    )
    @test ad isa AbstractADType
    @test ad isa AutoFiniteDiff
    @test mode(ad) isa ForwardMode
    @test ad.fdtype === Val(:central)
    @test ad.fdjtype === Val(:forward)
    @test ad.fdhtype === Val(:hcentral)
    @test ad.relstep == 1.0e-3
    @test ad.absstep == 1.0e-4
    @test !ad.dir
end

@testset "AutoFiniteDifferences" begin
    ad = AutoFiniteDifferences(; fdm = nothing)
    @test ad isa AbstractADType
    @test ad isa AutoFiniteDifferences{Nothing}
    @test mode(ad) isa ForwardMode
    @test ad.fdm === nothing

    ad = AutoFiniteDifferences(; fdm = Val(:forward_fdm))
    @test ad isa AbstractADType
    @test ad isa AutoFiniteDifferences{Val{:forward_fdm}}
    @test mode(ad) isa ForwardMode
    @test ad.fdm == Val(:forward_fdm)
end

@testset "AutoForwardDiff" begin
    ad = AutoForwardDiff()
    @test ad isa AbstractADType
    @test ad isa AutoForwardDiff{nothing, Nothing}
    @test mode(ad) isa ForwardMode
    @test ad.tag === nothing

    ad = AutoForwardDiff(; chunksize = 10, tag = CustomTag())
    @test ad isa AbstractADType
    @test ad isa AutoForwardDiff{10, CustomTag}
    @test mode(ad) isa ForwardMode
    @test ad.tag == CustomTag()
end

@testset "AutoGTPSA" begin
    ad = AutoGTPSA(; descriptor = nothing)
    @test ad isa AbstractADType
    @test ad isa AutoGTPSA{Nothing}
    @test mode(ad) isa ForwardMode
    @test ad.descriptor === nothing

    ad = AutoGTPSA(; descriptor = Val(:descriptor))
    @test ad isa AbstractADType
    @test ad isa AutoGTPSA{Val{:descriptor}}
    @test mode(ad) isa ForwardMode
    @test ad.descriptor == Val(:descriptor)
end

@testset "AutoHyperHessians" begin
    ad = AutoHyperHessians()
    @test ad isa AbstractADType
    @test ad isa AutoHyperHessians{nothing}
    @test mode(ad) isa ForwardMode

    ad = AutoHyperHessians(; chunksize = 8)
    @test ad isa AbstractADType
    @test ad isa AutoHyperHessians{8}
    @test mode(ad) isa ForwardMode

    @test_throws ArgumentError AutoHyperHessians(; chunksize = -1)
end

@testset "AutoMooncake" begin
    ad = AutoMooncake(; config = :config)
    @test ad isa AbstractADType
    @test ad isa AutoMooncake
    @test mode(ad) isa ReverseMode
    @test ad.config == :config
    ad = AutoMooncake()
    @test ad.config === nothing
end

@testset "AutoMooncakeForward" begin
    ad = AutoMooncakeForward(; config = :config)
    @test ad isa AbstractADType
    @test ad isa AutoMooncakeForward
    @test mode(ad) isa ForwardMode
    @test ad.config === :config
    ad = AutoMooncakeForward()
    @test ad.config === nothing
end

@testset "AutoPolyesterForwardDiff" begin
    ad = AutoPolyesterForwardDiff()
    @test ad isa AbstractADType
    @test ad isa AutoPolyesterForwardDiff{nothing, Nothing}
    @test mode(ad) isa ForwardMode
    @test ad.tag === nothing

    ad = AutoPolyesterForwardDiff(; chunksize = 10, tag = CustomTag())
    @test ad isa AbstractADType
    @test ad isa AutoPolyesterForwardDiff{10, CustomTag}
    @test mode(ad) isa ForwardMode
    @test ad.tag == CustomTag()
end

@testset "AutoReverseDiff" begin
    ad = @inferred AutoReverseDiff()
    @test ad isa AbstractADType
    @test ad isa AutoReverseDiff{false}
    @test mode(ad) isa ReverseMode
    @test !ad.compile
    @test_deprecated ad.compile

    ad = AutoReverseDiff(; compile = true)
    @test ad isa AbstractADType
    @test ad isa AutoReverseDiff{true}
    @test mode(ad) isa ReverseMode
    @test ad.compile
    @test_deprecated ad.compile

    ad = @inferred AutoReverseDiff(; compile = Val(true))
    @test ad isa AbstractADType
    @test ad isa AutoReverseDiff{true}
    @test mode(ad) isa ReverseMode
    @test ad.compile
    @test_deprecated ad.compile
end

@testset "AutoSymbolics" begin
    ad = AutoSymbolics()
    @test ad isa AbstractADType
    @test ad isa AutoSymbolics
    @test mode(ad) isa SymbolicMode
end

@testset "AutoTapir" begin
    ad = AutoTapir()
    @test ad isa AbstractADType
    @test ad isa AutoTapir
    @test mode(ad) isa ReverseMode
    @test ad.safe_mode

    ad = AutoTapir(; safe_mode = false)
    @test !ad.safe_mode
end

@testset "AutoTaylorDiff" begin
    ad = AutoTaylorDiff(; order = 2)
    @test ad isa AbstractADType
    @test ad isa AutoTaylorDiff{2}
    @test mode(ad) isa ForwardMode

    ad = AutoTaylorDiff()
    @test ad isa AbstractADType
    @test ad isa AutoTaylorDiff{1}
    @test mode(ad) isa ForwardMode
end

@testset "AutoTracker" begin
    ad = AutoTracker()
    @test ad isa AbstractADType
    @test ad isa AutoTracker
    @test mode(ad) isa ReverseMode
end

@testset "AutoZygote" begin
    ad = AutoZygote()
    @test ad isa AbstractADType
    @test ad isa AutoZygote
    @test mode(ad) isa ReverseMode
end

@testset "NoAutoDiff" begin
    ad = NoAutoDiff()
    @test ad isa AbstractADType
    @test ad isa NoAutoDiff
    @test_throws NoAutoDiffSelectedError mode(ad)
end

## Sparsity detector

"""
    AbstractSparsityDetector

Abstract supertype for sparsity pattern detectors.

# Extension contract

External detectors implement the supported public forms of
[`jacobian_sparsity`](@ref) and/or [`hessian_sparsity`](@ref). A Jacobian pattern
must be an `AbstractMatrix{Bool}` with shape `(length(y), length(x))`, where `y` is
`f(x)` for the out-of-place form or the supplied output buffer for the in-place
form. A Hessian pattern must be an `AbstractMatrix{Bool}` with shape
`(length(x), length(x))`. Methods for unsupported operations must throw an error;
they must not return an unrelated pattern.

New detectors should return `Bool` patterns, but consumers must not require `Bool`:
they should treat every nonzero entry as a structural nonzero. Patterns given as
integer or floating point matrices of ones and zeroes are common in the wild, are
accepted unchanged by [`KnownJacobianSparsityDetector`](@ref) and
[`KnownHessianSparsityDetector`](@ref), and are handled correctly by the coloring
and decompression implementations used downstream (SparseMatrixColorings.jl through
DifferentiationInterface.jl). The element type of the pattern does not propagate to
the differentiation result.

For a sparse matrix, the stored structure defines the pattern: an explicitly stored
zero is treated as a structural nonzero, which yields a valid but more conservative
coloring than the same matrix passed through `dropzeros`.
"""
abstract type AbstractSparsityDetector end

"""
    jacobian_sparsity(f, x, sd::AbstractSparsityDetector)::AbstractMatrix{Bool}
    jacobian_sparsity(f!, y, x, sd::AbstractSparsityDetector)::AbstractMatrix{Bool}

Use detector `sd` to construct a (typically sparse) matrix `S` describing the pattern of nonzeroes in the Jacobian of `f` (resp. `f!`) applied at `x` (resp. `(y, x)`).
"""
function jacobian_sparsity end

"""
    hessian_sparsity(f, x, sd::AbstractSparsityDetector)::AbstractMatrix{Bool}

Use detector `sd` to construct a (typically sparse) matrix `S` describing the pattern of nonzeroes in the Hessian of `f` applied at `x`.
"""
function hessian_sparsity end

"""
    NoSparsityDetector <: AbstractSparsityDetector

Trivial sparsity detector, which always returns a full sparsity pattern (only ones, no zeroes).

# See also

  - [`AbstractSparsityDetector`](@ref)
"""
struct NoSparsityDetector <: AbstractSparsityDetector end

jacobian_sparsity(f, x, ::NoSparsityDetector) = trues(length(f(x)), length(x))
jacobian_sparsity(f!, y, x, ::NoSparsityDetector) = trues(length(y), length(x))
hessian_sparsity(f, x, ::NoSparsityDetector) = trues(length(x), length(x))

"""
    KnownJacobianSparsityDetector(jacobian_sparsity::AbstractMatrix) <: AbstractSparsityDetector

Trivial sparsity detector used to return a known Jacobian sparsity pattern.

`AbstractMatrix{Bool}` is the canonical pattern type, but the element type is neither
converted nor checked: [`jacobian_sparsity`](@ref) hands the pattern back exactly as
given, and consumers treat every nonzero entry as a structural nonzero, so integer or
floating point matrices of ones and zeroes work as well (see the extension contract of
[`AbstractSparsityDetector`](@ref)).

# See also

  - [`AbstractSparsityDetector`](@ref)
  - [`KnownHessianSparsityDetector`](@ref)
"""
struct KnownJacobianSparsityDetector{J <: AbstractMatrix} <: AbstractSparsityDetector
    jacobian_sparsity::J
end

function jacobian_sparsity(f, x, sd::KnownJacobianSparsityDetector)
    sz = size(sd.jacobian_sparsity)
    sz_expected = (length(f(x)), length(x))
    sz != sz_expected &&
        throw(DimensionMismatch("Jacobian size $sz of KnownJacobianSparsityDetector doesn't match expected size $sz_expected."))
    return sd.jacobian_sparsity
end
function jacobian_sparsity(f!, y, x, sd::KnownJacobianSparsityDetector)
    sz = size(sd.jacobian_sparsity)
    sz_expected = (length(y), length(x))
    sz != sz_expected &&
        throw(DimensionMismatch("Jacobian size $sz of KnownJacobianSparsityDetector doesn't match expected size $sz_expected."))
    return sd.jacobian_sparsity
end
function hessian_sparsity(f, x, sd::KnownJacobianSparsityDetector)
    throw(ArgumentError("KnownJacobianSparsityDetector can't be used to compute Hessian sparsity."))
end

"""
    KnownHessianSparsityDetector(hessian_sparsity::AbstractMatrix) <: AbstractSparsityDetector

Trivial sparsity detector used to return a known Hessian sparsity pattern.

`AbstractMatrix{Bool}` is the canonical pattern type, but the element type is neither
converted nor checked: [`hessian_sparsity`](@ref) hands the pattern back exactly as
given, and consumers treat every nonzero entry as a structural nonzero, so integer or
floating point matrices of ones and zeroes work as well (see the extension contract of
[`AbstractSparsityDetector`](@ref)).

# See also

  - [`AbstractSparsityDetector`](@ref)
  - [`KnownJacobianSparsityDetector`](@ref)
"""
struct KnownHessianSparsityDetector{H <: AbstractMatrix} <: AbstractSparsityDetector
    hessian_sparsity::H
end

function hessian_sparsity(f, x, sd::KnownHessianSparsityDetector)
    sz = size(sd.hessian_sparsity)
    sz_expected = (length(x), length(x))
    sz != sz_expected &&
        throw(DimensionMismatch("Hessian size $sz of KnownHessianSparsityDetector doesn't match expected size $sz_expected."))
    return sd.hessian_sparsity
end

function jacobian_sparsity(f, x, sd::KnownHessianSparsityDetector)
    throw(ArgumentError("KnownHessianSparsityDetector can't be used to compute Jacobian sparsity."))
end
function jacobian_sparsity(f!, y, x, sd::KnownHessianSparsityDetector)
    throw(ArgumentError("KnownHessianSparsityDetector can't be used to compute Jacobian sparsity."))
end

## Coloring algorithm

"""
    AbstractColoringAlgorithm

Abstract supertype for Jacobian/Hessian coloring algorithms.

# Extension contract

External algorithms implement the supported public coloring functions. Each result
must be an `AbstractVector` of integers: column colorings have length `size(M, 2)`,
row colorings have length `size(M, 1)`, and symmetric colorings require a square
matrix and have length `size(M, 1)`. The assigned colors must satisfy the structural
orthogonality condition documented by each coloring function. Unsupported coloring
forms must throw an error.

# Note

The terminology and definitions are taken from the following paper:

> [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Assefaw Hadish Gebremedhin, Fredrik Manne, and Alex Pothen (2005)
"""
abstract type AbstractColoringAlgorithm end

"""
    column_coloring(M::AbstractMatrix, ca::AbstractColoringAlgorithm)::AbstractVector{<:Integer}

Use algorithm `ca` to construct a structurally orthogonal partition of the columns of `M`.

The result is a coloring vector `c` of length `size(M, 2)` such that for every non-zero coefficient `M[i, j]`, column `j` is the only column of its color `c[j]` with a non-zero coefficient in row `i`.
"""
function column_coloring end

"""
    row_coloring(M::AbstractMatrix, ca::AbstractColoringAlgorithm)::AbstractVector{<:Integer}

Use algorithm `ca` to construct a structurally orthogonal partition of the rows of `M`.

The result is a coloring vector `c` of length `size(M, 1)` such that for every non-zero coefficient `M[i, j]`, row `i` is the only row of its color `c[i]` with a non-zero coefficient in column `j`.
"""
function row_coloring end

"""
    symmetric_coloring(M::AbstractMatrix, ca::AbstractColoringAlgorithm)::AbstractVector{<:Integer}

Use algorithm `ca` to construct a symmetrically structurally orthogonal partition of the columns (or rows) of the symmetric matrix `M`.

The result is a coloring vector `c` of length `size(M, 1) == size(M, 2)` such that for every non-zero coefficient `M[i, j]`, at least one of the following conditions holds:

  - column `j` is the only column of its color `c[j]` with a non-zero coefficient in row `i`;
  - column `i` is the only column of its color `c[i]` with a non-zero coefficient in row `j`.
"""
function symmetric_coloring end

"""
    NoColoringAlgorithm <: AbstractColoringAlgorithm

Trivial coloring algorithm, which always returns a different color for each matrix column/row.

# See also

  - [`AbstractColoringAlgorithm`](@ref)
"""
struct NoColoringAlgorithm <: AbstractColoringAlgorithm end

column_coloring(M::AbstractMatrix, ::NoColoringAlgorithm) = 1:size(M, 2)
row_coloring(M::AbstractMatrix, ::NoColoringAlgorithm) = 1:size(M, 1)
symmetric_coloring(M::AbstractMatrix, ::NoColoringAlgorithm) = 1:size(M, 1)

## Sparse backend

"""
    AutoSparse{D,S,C}

Wraps an ADTypes.jl object to deal with sparse Jacobians and Hessians.

# Fields

  - `dense_ad::D`: the underlying AD package, subtyping [`AbstractADType`](@ref)
  - `sparsity_detector::S`: the sparsity pattern detector, subtyping [`AbstractSparsityDetector`](@ref)
  - `coloring_algorithm::C`: the coloring algorithm, subtyping [`AbstractColoringAlgorithm`](@ref)

# Constructors

    AutoSparse(
        dense_ad;
        sparsity_detector=ADTypes.NoSparsityDetector(),
        coloring_algorithm=ADTypes.NoColoringAlgorithm()
    )
"""
struct AutoSparse{
        D <: AbstractADType,
        S <: AbstractSparsityDetector,
        C <: AbstractColoringAlgorithm,
    } <: AbstractADType
    dense_ad::D
    sparsity_detector::S
    coloring_algorithm::C
end

function AutoSparse(
        dense_ad;
        sparsity_detector = NoSparsityDetector(),
        coloring_algorithm = NoColoringAlgorithm()
    )
    return AutoSparse{
        typeof(dense_ad),
        typeof(sparsity_detector),
        typeof(coloring_algorithm),
    }(dense_ad, sparsity_detector, coloring_algorithm)
end

function Base.show(io::IO, backend::AutoSparse)
    print(io, AutoSparse, "(dense_ad=", repr(backend.dense_ad, context = io))
    if backend.sparsity_detector != NoSparsityDetector()
        print(io, ", sparsity_detector=", repr(backend.sparsity_detector, context = io))
    end
    if backend.coloring_algorithm != NoColoringAlgorithm()
        print(
            io, ", coloring_algorithm=", repr(backend.coloring_algorithm, context = io)
        )
    end
    return print(io, ")")
end

"""
    dense_ad(ad::AutoSparse)::AbstractADType
    dense_ad(ad::AbstractADType)::AbstractADType

Return the underlying AD package for a sparse AD choice, act as the identity on a dense AD choice.

# See also

  - [`AutoSparse`](@ref)
"""
dense_ad(ad::AutoSparse) = ad.dense_ad
dense_ad(ad::AbstractADType) = ad

mode(sparse_ad::AutoSparse) = mode(dense_ad(sparse_ad))

"""
    sparsity_detector(ad::AutoSparse)::AbstractSparsityDetector

Return the sparsity pattern detector for a sparse AD choice.

# See also

  - [`AutoSparse`](@ref)
  - [`AbstractSparsityDetector`](@ref)
"""
sparsity_detector(ad::AutoSparse) = ad.sparsity_detector

"""
    coloring_algorithm(ad::AutoSparse)::AbstractColoringAlgorithm

Return the coloring algorithm for a sparse AD choice.

# See also

  - [`AutoSparse`](@ref)
  - [`AbstractColoringAlgorithm`](@ref)
"""
coloring_algorithm(ad::AutoSparse) = ad.coloring_algorithm

include(joinpath(@__DIR__, "shared", "test_setup.jl"))

@testset "Broadcasting" begin
    for ad in every_ad()
        @test identity.(ad) == ad
    end
end

@testset "Printing" begin
    for ad in every_ad_with_options()
        @test startswith(string(ad), "Auto")
        @test contains(string(ad), "(")
        @test endswith(string(ad), ")")
    end

    sparse_backend1 = AutoSparse(AutoForwardDiff())
    sparse_backend2 = AutoSparse(
        AutoForwardDiff();
        sparsity_detector = FakeSparsityDetector(),
        coloring_algorithm = FakeColoringAlgorithm()
    )
    @test contains(string(sparse_backend1), string(AutoForwardDiff()))
    @test length(string(sparse_backend1)) < length(string(sparse_backend2))
end

#=
The following tests are only for visual assessment of the printing behavior.
They do not correspond to proper use of ADTypes constructors.
Please refer to the docstrings for that.
=#
for backend in [
        # dense
        ADTypes.AutoChainRules(; ruleconfig = :rc),
        ADTypes.AutoDiffractor(),
        ADTypes.AutoEnzyme(),
        ADTypes.AutoEnzyme(mode = :forward),
        ADTypes.AutoEnzyme(function_annotation = Val{:forward}),
        ADTypes.AutoEnzyme(mode = :reverse, function_annotation = Val{:duplicated}),
        ADTypes.AutoFastDifferentiation(),
        ADTypes.AutoFiniteDiff(),
        ADTypes.AutoFiniteDiff(fdtype = :fd, fdjtype = :fdj, fdhtype = :fdh),
        ADTypes.AutoFiniteDifferences(; fdm = :fdm),
        ADTypes.AutoForwardDiff(),
        ADTypes.AutoForwardDiff(chunksize = 3, tag = :tag),
        ADTypes.AutoGTPSA(),
        ADTypes.AutoGTPSA(; descriptor = Val(:descriptor)),
        ADTypes.AutoMooncake(),
        ADTypes.AutoMooncake(; config = :config),
        ADTypes.AutoMooncakeForward(),
        ADTypes.AutoMooncakeForward(; config = :config),
        ADTypes.AutoPolyesterForwardDiff(),
        ADTypes.AutoPolyesterForwardDiff(chunksize = 3, tag = :tag),
        ADTypes.AutoReverseDiff(),
        ADTypes.AutoReverseDiff(compile = true),
        ADTypes.AutoSymbolics(),
        ADTypes.AutoTapir(),
        ADTypes.AutoTapir(safe_mode = false),
        ADTypes.AutoTracker(),
        ADTypes.AutoZygote(),
        # sparse
        ADTypes.AutoSparse(ADTypes.AutoForwardDiff()),
        ADTypes.AutoSparse(
            ADTypes.AutoForwardDiff();
            sparsity_detector = FakeSparsityDetector(),
            coloring_algorithm = FakeColoringAlgorithm()
        ),
    ]
    println(backend)
end

using Setfield

@testset "Setfield compatibility" begin
    ad = AutoEnzyme()
    @test ad.mode === nothing
    @set! ad.mode = EnzymeCore.Reverse
    @test ad.mode isa EnzymeCore.ReverseMode

    struct CustomTestTag end

    ad = AutoForwardDiff()
    @test ad.tag === nothing
    @set! ad.tag = CustomTestTag()
    @test ad.tag isa CustomTestTag

    ad = AutoForwardDiff(; chunksize = 10)
    @test ad.tag === nothing
    @set! ad.tag = CustomTestTag()
    @test ad.tag isa CustomTestTag
    @test ad isa AutoForwardDiff{10}

    ad = AutoPolyesterForwardDiff()
    @test ad.tag === nothing
    @set! ad.tag = CustomTestTag()
    @test ad.tag isa CustomTestTag

    ad = AutoPolyesterForwardDiff(; chunksize = 10)
    @test ad.tag === nothing
    @set! ad.tag = CustomTestTag()
    @test ad.tag isa CustomTestTag
    @test ad isa AutoPolyesterForwardDiff{10}
end

using ADTypes
using Test

@test ADTypes.Auto(:ChainRules, 1) isa AutoChainRules{Int64}
@test ADTypes.Auto(:Diffractor) isa AutoDiffractor
@test ADTypes.Auto(:Enzyme) isa AutoEnzyme
@test ADTypes.Auto(:FastDifferentiation) isa AutoFastDifferentiation
@test ADTypes.Auto(:FiniteDiff) isa AutoFiniteDiff
@test ADTypes.Auto(:FiniteDifferences, 1.0) isa AutoFiniteDifferences{Float64}
@test ADTypes.Auto(:ForwardDiff) isa AutoForwardDiff
@test ADTypes.Auto(:HyperHessians) isa AutoHyperHessians
@test ADTypes.Auto(:Mooncake) isa AutoMooncake
@test ADTypes.Auto(:PolyesterForwardDiff) isa AutoPolyesterForwardDiff
@test ADTypes.Auto(:ReverseDiff) isa AutoReverseDiff
@test ADTypes.Auto(:Reactant) isa AutoReactant
@test ADTypes.Auto(:Symbolics) isa AutoSymbolics
@test ADTypes.Auto(:Tapir) isa AutoTapir
@test ADTypes.Auto(:Tracker) isa AutoTracker
@test ADTypes.Auto(:Zygote) isa AutoZygote
@test ADTypes.Auto(nothing) isa NoAutoDiff

@test_throws MethodError ADTypes.Auto(:ThisPackageDoesNotExist)
@test_throws UndefKeywordError ADTypes.Auto(:ChainRules)
@test_throws UndefKeywordError ADTypes.Auto(:FiniteDifferences)

"""
    ADTypes.jl

[ADTypes.jl](https://github.com/SciML/ADTypes.jl) is a multi-valued logic system to choose an automatic differentiation (AD) package and specify its parameters.
"""
module ADTypes

using Base: @deprecate

"""
    AbstractADType

Abstract supertype for all AD choices.

# Extension contract

External packages may subtype `AbstractADType` to describe an AD backend. They must
also implement [`mode`](@ref) for their concrete subtype and return an instance of
an [`AbstractMode`](@ref) subtype. Consumers should dispatch on `mode(ad)`, rather
than on a downstream concrete AD type.
"""
abstract type AbstractADType end

Base.broadcastable(ad::AbstractADType) = Ref(ad)

@inline _unwrap_val(::Val{T}) where {T} = T
@inline _unwrap_val(x) = x

include("compat.jl") # @public macro
include("mode.jl")
include("dense.jl")
include("sparse.jl")
include("legacy.jl")
include("symbols.jl")

# Automatic Differentiation
export AbstractADType
export AutoChainRules,
    AutoDiffractor,
    AutoEnzyme,
    AutoFastDifferentiation,
    AutoFiniteDiff,
    AutoFiniteDifferences,
    AutoForwardDiff,
    AutoGTPSA,
    AutoHyperHessians,
    AutoModelingToolkit,
    AutoMooncake,
    AutoMooncakeForward,
    AutoPolyesterForwardDiff,
    AutoReverseDiff,
    AutoSymbolics,
    AutoTapir,
    AutoTaylorDiff,
    AutoTracker,
    AutoZygote,
    NoAutoDiff,
    NoAutoDiffSelectedError,
    AutoReactant
@public AbstractMode
@public ForwardMode, ReverseMode, ForwardOrReverseMode, SymbolicMode
@public mode
@public Auto

# Sparse Automatic Differentiation
export AutoSparse
@public dense_ad

# Sparsity detection
export AbstractSparsityDetector
export jacobian_sparsity, hessian_sparsity
@public sparsity_detector
@public NoSparsityDetector
@public KnownJacobianSparsityDetector
@public KnownHessianSparsityDetector

# Matrix coloring
export AbstractColoringAlgorithm
export column_coloring, row_coloring, symmetric_coloring
@public coloring_algorithm
@public NoColoringAlgorithm

# legacy exports are taken care of by @deprecated

end

using Documenter
using ADTypes

makedocs(
    sitename = "ADTypes",
    format = Documenter.HTML(),
    modules = [ADTypes],
    doctest = true,
    checkdocs = :exports,
)

deploydocs(
    repo = "github.com/SciML/ADTypes.jl.git"
)

using SafeTestsets
using SciMLTesting
# `using ADTypes` in Main is load-bearing for the printing tests: Julia qualifies a
# type's module in `show` based on visibility in `Base.active_module()` (Main), not the
# module the test runs in. Without it, `string(AutoForwardDiff())` becomes
# "ADTypes.AutoForwardDiff()" and the `startswith(..., "Auto")` assertions fail.
using ADTypes

run_tests(;
    core = function ()
        @safetestset "Dense" include("dense.jl")
        @safetestset "Sparse" include("sparse.jl")
        @safetestset "Symbols" include("symbols.jl")
        @safetestset "Legacy" include("legacy.jl")
        @safetestset "Miscellaneous" include("misc.jl")
        return if VERSION >= v"1.11.0-DEV.469"
            @safetestset "Public" include("public.jl")
        end
    end,
    qa = (;
        env = joinpath(@__DIR__, "qa"),
        body = joinpath(@__DIR__, "qa", "qa.jl")
    ),
)

using ADTypes
using ADTypes: AbstractADType,
    mode,
    ForwardMode,
    ForwardOrReverseMode,
    ReverseMode,
    SymbolicMode
using ADTypes: dense_ad,
    NoSparsityDetector,
    KnownJacobianSparsityDetector,
    KnownHessianSparsityDetector,
    sparsity_detector,
    jacobian_sparsity,
    hessian_sparsity,
    NoColoringAlgorithm,
    coloring_algorithm,
    column_coloring,
    row_coloring,
    symmetric_coloring
using ChainRulesCore: ChainRulesCore, RuleConfig,
    HasForwardsMode, HasReverseMode,
    NoForwardsMode, NoReverseMode
using EnzymeCore: EnzymeCore
using Test

struct CustomTag end

struct ForwardRuleConfig <: RuleConfig{Union{HasForwardsMode, NoReverseMode}} end
struct ReverseRuleConfig <: RuleConfig{Union{NoForwardsMode, HasReverseMode}} end
struct ForwardOrReverseRuleConfig <: RuleConfig{Union{HasForwardsMode, HasReverseMode}} end

struct FakeSparsityDetector <: ADTypes.AbstractSparsityDetector end
struct FakeColoringAlgorithm <: ADTypes.AbstractColoringAlgorithm end

function every_ad()
    return [
        AutoChainRules(; ruleconfig = :rc),
        AutoDiffractor(),
        AutoEnzyme(),
        AutoFastDifferentiation(),
        AutoFiniteDiff(),
        AutoFiniteDifferences(; fdm = :fdm),
        AutoForwardDiff(),
        AutoGTPSA(),
        AutoHyperHessians(),
        AutoPolyesterForwardDiff(),
        AutoReverseDiff(),
        AutoSymbolics(),
        AutoTapir(),
        AutoTracker(),
        AutoZygote(),
    ]
end

function every_ad_with_options()
    return [
        AutoChainRules(; ruleconfig = :rc),
        AutoDiffractor(),
        AutoEnzyme(),
        AutoEnzyme(mode = :forward),
        AutoFastDifferentiation(),
        AutoFiniteDiff(),
        AutoFiniteDiff(
            fdtype = :fd, fdjtype = :fdj, fdhtype = :fdh,
            relstep = 1, absstep = 2, dir = false
        ),
        AutoFiniteDifferences(; fdm = :fdm),
        AutoForwardDiff(),
        AutoForwardDiff(chunksize = 3, tag = :tag),
        AutoGTPSA(),
        AutoGTPSA(descriptor = Val(:descriptor)),
        AutoHyperHessians(),
        AutoHyperHessians(chunksize = 8),
        AutoMooncake(; config = :config),
        AutoMooncakeForward(; config = :config),
        AutoPolyesterForwardDiff(),
        AutoPolyesterForwardDiff(chunksize = 3, tag = :tag),
        AutoReverseDiff(),
        AutoReverseDiff(compile = true),
        AutoSymbolics(),
        AutoTapir(),
        AutoTapir(safe_mode = false),
        AutoTracker(),
        AutoZygote(),
    ]
end

using ADTypes
using Test

public_symbols = (
    :AbstractMode,
    :ForwardMode,
    :ReverseMode,
    :ForwardOrReverseMode,
    :SymbolicMode,
    :mode,
    :Auto,
    # Sparse Automatic Differentiation
    :dense_ad,
    # Sparsity detection
    :sparsity_detector,
    :NoSparsityDetector,
    :KnownJacobianSparsityDetector,
    :KnownHessianSparsityDetector,
    # Matrix coloring
    :coloring_algorithm,
    :NoColoringAlgorithm,
)
@test public_symbols ⊆ names(ADTypes)

"""
    ADTypes.Auto(package::Symbol)
    ADTypes.Auto(nothing)::NoAutoDiff

A shortcut that converts an AD package name into an instance of [`AbstractADType`](@ref), with all parameters set to their default values.

!!! warning

    This function is type-unstable by design and might lead to suboptimal performance.
    In most cases, you should never need it: use the individual backend types directly.

# Example

```jldoctest
import ADTypes
backend = ADTypes.Auto(:Zygote)

# output

ADTypes.AutoZygote()
```
"""
Auto(package::Symbol, args...; kws...) = Auto(Val(package), args...; kws...)

for backend in (
        :ChainRules, :Diffractor, :Enzyme, :Reactant, :FastDifferentiation,
        :FiniteDiff, :FiniteDifferences, :ForwardDiff, :GTPSA, :HyperHessians, :Mooncake,
        :PolyesterForwardDiff, :ReverseDiff, :Symbolics, :Tapir, :TaylorDiff, :Tracker, :Zygote,
    )
    @eval Auto(::Val{$(QuoteNode(backend))}, args...; kws...) = $(Symbol(:Auto, backend))(
        args...; kws...
    )
end

Auto(::Nothing) = NoAutoDiff()

using ADTypes
using ADTypes: Auto, AutoForwardDiff, AutoReverseDiff, AutoSparse, ForwardMode,
    ReverseMode, NoAutoDiff, dense_ad, sparsity_detector, coloring_algorithm,
    NoSparsityDetector, KnownJacobianSparsityDetector,
    KnownHessianSparsityDetector, jacobian_sparsity, hessian_sparsity,
    NoColoringAlgorithm, column_coloring, row_coloring, symmetric_coloring, mode
using Test

forward_ad = AutoForwardDiff(; chunksize = 4)
@test mode(forward_ad) isa ForwardMode
@test mode(AutoReverseDiff(; compile = true)) isa ReverseMode
@test Auto(:ForwardDiff) isa AutoForwardDiff
@test Auto(nothing) isa NoAutoDiff

sparse_ad = AutoSparse(forward_ad)
@test dense_ad(sparse_ad) === forward_ad
@test sparsity_detector(sparse_ad) isa NoSparsityDetector
@test coloring_algorithm(sparse_ad) isa NoColoringAlgorithm

x = [1.0, 2.0]
f(x) = [x[1]^2, x[2]^2]
@test jacobian_sparsity(f, x, NoSparsityDetector()) == trues(2, 2)
@test hessian_sparsity(sum, x, NoSparsityDetector()) == trues(2, 2)

pattern = trues(2, 2)
@test jacobian_sparsity(f, x, KnownJacobianSparsityDetector(pattern)) === pattern
@test hessian_sparsity(sum, x, KnownHessianSparsityDetector(pattern)) === pattern

matrix = trues(2, 3)
coloring = NoColoringAlgorithm()
@test column_coloring(matrix, coloring) == 1:3
@test row_coloring(matrix, coloring) == 1:2
@test symmetric_coloring(pattern, coloring) == 1:2

module ADTypesConstructionBaseExt

using ADTypes: AutoEnzyme, AutoForwardDiff, AutoPolyesterForwardDiff
using ConstructionBase: ConstructionBase

struct InternalAutoEnzymeReconstructor{A} end

InternalAutoEnzymeReconstructor{A}(mode::M) where {M, A} = AutoEnzyme{M, A}(mode)

function ConstructionBase.constructorof(::Type{<:AutoEnzyme{M, A}}) where {M, A}
    return InternalAutoEnzymeReconstructor{A}
end

function ConstructionBase.constructorof(::Type{<:AutoForwardDiff{chunksize}}) where {chunksize}
    return AutoForwardDiff{chunksize}
end

function ConstructionBase.constructorof(::Type{<:AutoPolyesterForwardDiff{chunksize}}) where {chunksize}
    return AutoPolyesterForwardDiff{chunksize}
end

end

@deprecate AutoSparseFastDifferentiation() AutoSparse(AutoFastDifferentiation())

@doc """
    AutoSparseFastDifferentiation()

!!! danger

    `AutoSparseFastDifferentiation` is deprecated, use
    `AutoSparse(AutoFastDifferentiation())` instead.

Deprecated constructor returning `AutoSparse(AutoFastDifferentiation())`.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
""" AutoSparseFastDifferentiation

@deprecate AutoSparseFiniteDiff(; kwargs...) AutoSparse(AutoFiniteDiff(; kwargs...))

@doc """
    AutoSparseFiniteDiff(; kwargs...)

!!! danger

    `AutoSparseFiniteDiff` is deprecated, use
    `AutoSparse(AutoFiniteDiff(; kwargs...))` instead.

Deprecated constructor returning `AutoSparse(AutoFiniteDiff(; kwargs...))`.
All keyword arguments are forwarded to [`AutoFiniteDiff`](@ref).

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
""" AutoSparseFiniteDiff

@deprecate AutoSparseForwardDiff(; kwargs...) AutoSparse(AutoForwardDiff(; kwargs...))

@doc """
    AutoSparseForwardDiff(; chunksize=nothing, tag=nothing)

!!! danger

    `AutoSparseForwardDiff` is deprecated, use
    `AutoSparse(AutoForwardDiff(; chunksize, tag))` instead.

Deprecated constructor returning `AutoSparse(AutoForwardDiff(; kwargs...))`.
All keyword arguments are forwarded to [`AutoForwardDiff`](@ref).

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
""" AutoSparseForwardDiff

@deprecate AutoSparsePolyesterForwardDiff(; kwargs...) AutoSparse(
    AutoPolyesterForwardDiff(;
        kwargs...
    )
)

@doc """
    AutoSparsePolyesterForwardDiff(; chunksize=nothing, tag=nothing)

!!! danger

    `AutoSparsePolyesterForwardDiff` is deprecated, use
    `AutoSparse(AutoPolyesterForwardDiff(; chunksize, tag))` instead.

Deprecated constructor returning `AutoSparse(AutoPolyesterForwardDiff(; kwargs...))`.
All keyword arguments are forwarded to [`AutoPolyesterForwardDiff`](@ref).

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
""" AutoSparsePolyesterForwardDiff

@deprecate AutoSparseReverseDiff(; kwargs...) AutoSparse(AutoReverseDiff(; kwargs...))

@deprecate AutoSparseReverseDiff(compile) AutoSparse(AutoReverseDiff(; compile))

@doc """
    AutoSparseReverseDiff(; compile::Union{Val, Bool}=Val(false))
    AutoSparseReverseDiff(compile)

!!! danger

    `AutoSparseReverseDiff` is deprecated, use
    `AutoSparse(AutoReverseDiff(; compile))` instead.

Deprecated constructor returning `AutoSparse(AutoReverseDiff(; compile))`.
The `compile` setting is forwarded to [`AutoReverseDiff`](@ref).

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
""" AutoSparseReverseDiff

@deprecate AutoSparseZygote() AutoSparse(AutoZygote())

@doc """
    AutoSparseZygote()

!!! danger

    `AutoSparseZygote` is deprecated, use `AutoSparse(AutoZygote())` instead.

Deprecated constructor returning `AutoSparse(AutoZygote())`.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
""" AutoSparseZygote

@deprecate AutoReverseDiff(compile) AutoReverseDiff(; compile)

function mtk_to_symbolics(obj_sparse::Bool, cons_sparse::Bool)
    if obj_sparse || cons_sparse
        return AutoSparse(AutoSymbolics())
    else
        return AutoSymbolics()
    end
end

"""
    AutoModelingToolkit(obj_sparse::Bool, cons_sparse::Bool)
    AutoModelingToolkit(; obj_sparse::Bool=false, cons_sparse::Bool=false)

!!! danger

    `AutoModelingToolkit` is deprecated, use [`AutoSymbolics`](@ref) or
    `AutoSparse(AutoSymbolics())` instead.

Deprecated symbolic automatic differentiation selector. It returns
`AutoSparse(AutoSymbolics())` when either sparsity flag is `true`, and
[`AutoSymbolics`](@ref) otherwise.

Defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
"""
function AutoModelingToolkit(obj_sparse::Bool, cons_sparse::Bool)
    Base.depwarn(
        "`AutoModelingToolkit(obj_sparse, cons_sparse)` is deprecated, use `AutoSymbolics()` or `AutoSparse(AutoSymbolics())` instead.",
        :AutoModelingToolkit; force = false
    )
    return mtk_to_symbolics(obj_sparse, cons_sparse)
end

function AutoModelingToolkit(; obj_sparse::Bool = false, cons_sparse::Bool = false)
    Base.depwarn(
        "`AutoModelingToolkit(; obj_sparse, cons_sparse)` is deprecated, use `AutoSymbolics()` or `AutoSparse(AutoSymbolics())` instead.",
        :AutoModelingToolkit; force = false
    )
    return mtk_to_symbolics(obj_sparse, cons_sparse)
end

function AutoTapir(; safe_mode = true)
    Base.depwarn(
        "`AutoTapir` is deprecated in favour of `AutoMooncake`.", :AutoTapir; force = false
    )
    return AutoTapir(safe_mode)
end

include(joinpath(@__DIR__, "shared", "test_setup.jl"))

@testset "AutoModelingToolkit" begin
    ad_sparse1 = @test_deprecated AutoModelingToolkit(;
        obj_sparse = true, cons_sparse = false
    )
    ad_sparse2 = @test_deprecated AutoModelingToolkit(true, false)

    ad_dense1 = @test_deprecated AutoModelingToolkit(;
        obj_sparse = false, cons_sparse = false
    )
    ad_dense2 = @test_deprecated AutoModelingToolkit(false, false)
    ad_dense3 = @test_deprecated AutoModelingToolkit()

    @test all(
        isa.((ad_sparse1, ad_sparse2, ad_dense1, ad_dense2, ad_dense3), AbstractADType)
    )
    @test all(isa.((ad_sparse1, ad_sparse2), AutoSparse{<:AutoSymbolics}))
    @test all(isa.((ad_dense1, ad_dense2, ad_dense3), AutoSymbolics))
end

@testset "AutoSparseFastDifferentiation" begin
    ad = @test_deprecated AutoSparseFastDifferentiation()
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoFastDifferentiation
end

@testset "AutoSparseFiniteDiff" begin
    ad = @test_deprecated AutoSparseFiniteDiff()
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoFiniteDiff
    @test dense_ad(ad).fdtype === Val(:forward)
    @test dense_ad(ad).fdjtype === Val(:forward)
    @test dense_ad(ad).fdhtype === Val(:hcentral)
end

@testset "AutoSparseForwardDiff" begin
    ad = @test_deprecated AutoSparseForwardDiff()
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoForwardDiff{nothing, Nothing}

    ad = @test_deprecated AutoSparseForwardDiff(; chunksize = 10, tag = CustomTag())
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoForwardDiff{10, CustomTag}
end

@testset "AutoSparsePolyesterForwardDiff" begin
    ad = @test_deprecated AutoSparsePolyesterForwardDiff(;
        chunksize = 10, tag = CustomTag()
    )
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoPolyesterForwardDiff{10, CustomTag}
end

@testset "AutoSparseReverseDiff" begin
    ad = @test_deprecated AutoSparseReverseDiff(; compile = true)
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoReverseDiff
    @test dense_ad(ad).compile

    ad = @test_deprecated AutoSparseReverseDiff(true)
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoReverseDiff
    @test dense_ad(ad).compile
end

@testset "AutoSparseZygote" begin
    ad = @test_deprecated AutoSparseZygote()
    @test ad isa AbstractADType
    @test dense_ad(ad) isa AutoZygote
end

@testset "AutoReverseDiff without kwarg" begin
    ad = @test_deprecated AutoReverseDiff(true)
    @test ad.compile
end

@testset "AutoTapir" begin
    @test_deprecated AutoTapir()
    @test_deprecated AutoTapir(; safe_mode = false)
end

```@meta
CurrentModule = ADTypes
CollapsedDocStrings = true
```

# ADTypes.jl

Documentation for [ADTypes.jl](https://github.com/SciML/ADTypes.jl/).

```@docs
ADTypes
AbstractADType
```

## Dense AD

### Forward mode

Algorithmic differentiation:

```@docs
AutoForwardDiff
AutoPolyesterForwardDiff
AutoMooncakeForward
```

Finite differences:

```@docs
AutoFiniteDiff
AutoFiniteDifferences
```

Taylor mode:

```@docs
AutoGTPSA
AutoTaylorDiff
AutoHyperHessians
```

### Reverse mode

```@docs
AutoMooncake
AutoReverseDiff
AutoTracker
AutoZygote
```

### Forward or reverse mode

```@docs
AutoEnzyme
AutoChainRules
AutoDiffractor
```

### Forward, reverse, or sparse mode

```@docs
AutoReactant
```

### Symbolic mode

```@docs
AutoFastDifferentiation
AutoSymbolics
```

## Sparse AD

```@docs
AutoSparse
ADTypes.dense_ad
```

### Sparsity detector

```@docs
ADTypes.sparsity_detector
ADTypes.AbstractSparsityDetector
ADTypes.jacobian_sparsity
ADTypes.hessian_sparsity
ADTypes.NoSparsityDetector
ADTypes.KnownJacobianSparsityDetector
ADTypes.KnownHessianSparsityDetector
```

### Coloring algorithm

```@docs
ADTypes.coloring_algorithm
ADTypes.AbstractColoringAlgorithm
ADTypes.column_coloring
ADTypes.row_coloring
ADTypes.symmetric_coloring
ADTypes.NoColoringAlgorithm
```

## No automatic differentiation

```@docs
NoAutoDiff
NoAutoDiffSelectedError
```

## Modes

```@docs
ADTypes.mode
ADTypes.AbstractMode
ADTypes.ForwardMode
ADTypes.ForwardOrReverseMode
ADTypes.ReverseMode
ADTypes.SymbolicMode
```

## Miscellaneous

```@docs
ADTypes.Auto
```

## Deprecated

```@docs
AutoModelingToolkit
AutoSparseFastDifferentiation
AutoSparseFiniteDiff
AutoSparseForwardDiff
AutoSparsePolyesterForwardDiff
AutoSparseReverseDiff
AutoSparseZygote
AutoTapir
```
